﻿using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            Loaded += Window_Loaded;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 윈도우 로드시 처리하기 - Window_Loaded(sender, e)

        /// <summary>
        /// 윈도우 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            BitmapSource bitmapSource = BitmapFrame.Create
            (
                new Uri
                (
                    "IMAGE/sample.jpg",
                    UriKind.RelativeOrAbsolute
                )
            );

            TransformedBitmap transformedBitmap = new TransformedBitmap();

            transformedBitmap.BeginInit();

            transformedBitmap.Source    = bitmapSource;
            transformedBitmap.Transform = new ScaleTransform(0.5, 0.5, 25, 25);

            transformedBitmap.EndInit();

            CachedBitmap cachedBitmap = new CachedBitmap
            (
                transformedBitmap, 
                BitmapCreateOptions.None,
                BitmapCacheOption.OnLoad
            );

            FormatConvertedBitmap formatConvertedBitmap = new FormatConvertedBitmap();

            formatConvertedBitmap.BeginInit();

            formatConvertedBitmap.DestinationFormat = PixelFormats.Gray32Float;
            formatConvertedBitmap.Source            = cachedBitmap;

            formatConvertedBitmap.EndInit();

            this.image.Source = formatConvertedBitmap;
        }

        #endregion
    }
}